#updated 20220902
#oag3pRetroArch.ps1

function Get-RetroArchFriendlyPlatformName([parameter(mandatory)][string]$sPlatformName,[parameter()][bool]$bInvert = $false) {
#convert platform name from Playnite to RetroArch
#updated 20220902
	$sFriendlyPlatform = $sPlatformName

	if ($bInvert -eq $false) {
		if ($sFriendlyPlatform -match 'Nintendo ') {
			$sFriendlyPlatform = switch ($sFriendlyPlatform) {
				'Nintendo 3DS' {"Nintendo - $sFriendlyPlatform"}
				'Nintendo 64' {"Nintendo - $sFriendlyPlatform"}
				'Nintendo 64DD' {"Nintendo - $sFriendlyPlatform"}
				'Nintendo DS' {"Nintendo - $sFriendlyPlatform"}
				'Nintendo Entertainment System' {"Nintendo - $sFriendlyPlatform"}
				'Super Nintendo Entertainment System' {"Nintendo - $sFriendlyPlatform"}
				default {$sFriendlyPlatform.replace('Nintendo ','Nintendo - ')}
			}
		} elseif ($sFriendlyPlatform.StartsWith('NEC ')) {
			if ($sFriendlyPlatform -match ' PC') {
				$sFriendlyPlatform = $sFriendlyPlatform.replace('NEC ','NEC - ').replace('01','')
			} else {
				$sFriendlyPlatform = switch ($sFriendlyPlatform) {
					'NEC SuperGrafx' {'NEC - PC Engine SuperGrafx'}
					'NEC TurboGrafx 16' {'NEC - PC Engine - TurboGrafx 16'}
					'NEC TurboGrafx-CD' {'NEC - PC Engine CD - TurboGrafx-CD'}
				}
			}
		} else {
			switch ($sFriendlyPlatform) {
				'3DO Interactive Multiplayer' {$sFriendlyPlatform = 'The 3DO Company - 3DO'}
				'Arcade' {$sFriendlyPlatform = 'MAME'}
				'Daphne' {$sFriendlyPlatform = 'Pioneer - Laseractive'}
				'Laserdisc' {$sFriendlyPlatform = 'Pioneer - Laseractive'}
				'MAME 2003 Plus' {$sFriendlyPlatform = 'MAME 2003-Plus'}
				'Sega CD' {$sFriendlyPlatform = 'Sega - Mega-CD - Sega CD'}
				'Sega Genesis' {$sFriendlyPlatform = 'Sega - Mega Drive - Genesis'}
				'Sega Master System' {$sFriendlyPlatform = 'Sega - Master System - Mark III'}
				#'Sega Model 2' {$sFriendlyPlatform = 'MAME'}
				'Sega SG 1000' {$sFriendlyPlatform = 'Sega - SG-1000'}
				'Sony PSP' {$sFriendlyPlatform = 'Sony - PlayStation Portable'}
				default {
					$sFriendlyPlatform = $sFriendlyPlatform.replace('Atari ','Atari - ')
					$sFriendlyPlatform = $sFriendlyPlatform.replace('Capcom ','Capcom - ')
					$sFriendlyPlatform = $sFriendlyPlatform.replace('Coleco ','Coleco - ')
					$sFriendlyPlatform = $sFriendlyPlatform.replace('Commodore ','Commodore - ')
					$sFriendlyPlatform = $sFriendlyPlatform.replace('Microsoft ','Microsoft - ')
					$sFriendlyPlatform = $sFriendlyPlatform.replace('Sega ','Sega - ')
					$sFriendlyPlatform = $sFriendlyPlatform.replace('Sharp ','Sharp - ')
					$sFriendlyPlatform = $sFriendlyPlatform.replace('Sinclair ','Sinclair - ')
					$sFriendlyPlatform = $sFriendlyPlatform.replace('SNK ','SNK - ')
					$sFriendlyPlatform = $sFriendlyPlatform.replace('Sony ','Sony - ')
				}
			}
		}
	} else {
		# drop file ext from RA playlist
		$sFriendlyPlatform = $sFriendlyPlatform.replace('.lpl', '')

		if ($sFriendlyPlatform -match 'Nintendo ') {
			$sFriendlyPlatform = $sFriendlyPlatform.replace('Nintendo - ','Nintendo ')
			$sFriendlyPlatform = $sFriendlyPlatform.replace('Nintendo Nintendo ','Nintendo ')
		} elseif ($sFriendlyPlatform.StartsWith('NEC ')) {
			$sFriendlyPlatform = switch ($sFriendlyPlatform) {
				'NEC - PC Engine SuperGrafx' {'NEC SuperGrafx'}
				'NEC - PC Engine - TurboGrafx 16' {'NEC TurboGrafx 16'}
				'NEC - PC Engine CD - TurboGrafx-CD' {'NEC TurboGrafx-CD'}
			}
			$sFriendlyPlatform = $sFriendlyPlatform.replace('NEC - ','NEC ')
			if ($sFriendlyPlatform.EndsWith(8)) {
				$sFriendlyPlatform = $sFriendlyPlatform + '01'
			}
		} else {
			switch ($sFriendlyPlatform) {
				'The 3DO Company - 3DO' {$sFriendlyPlatform = '3DO Interactive Multiplayer'}
				'MAME' {$sFriendlyPlatform = 'Arcade'}
				#'Pioneer - Laseractive' {$sFriendlyPlatform = 'Daphne'}
				'Pioneer - Laseractive' {$sFriendlyPlatform = 'Laserdisc'}
				'MAME 2003-Plus' {$sFriendlyPlatform = 'MAME 2003 Plus'}
				'Sega - Mega-CD - Sega CD' {$sFriendlyPlatform = 'Sega CD'}
				'Sega - Mega Drive - Genesis' {$sFriendlyPlatform = 'Sega Genesis'}
				'Sega - Master System - Mark III' {$sFriendlyPlatform = 'Sega Master System'}
				'Sega - SG-1000' {$sFriendlyPlatform = 'Sega SG 1000'}
				'Sony - PlayStation Portable' {$sFriendlyPlatform = 'Sony PSP'}
				default {
					$sFriendlyPlatform = $sFriendlyPlatform.replace(' - ',' ')
				}
			}
		}
	}

	return $sFriendlyPlatform
}